######################################################
# excuting, editing and icon information via ttb.if2
#
# mode: 0=exec 1=edit 2=iconInfo
#
proc ttb_execIF2 {filenames mode} {
	global ttblibPath ttbTerm

	set filenames [split $filenames \n]

	for {set counter 0} {$counter<[llength $filenames]} {incr counter} {

		set filename [lindex $filenames $counter]

		if {[file isdirectory $filename]} {
			cd $filename
			continue
		}

		if {[string range $filename 0 0]=="."} {
			if {$mode==0} {exec $ttbTerm -e less $filename}
			if {$mode==1} {exec $ttbTerm -e joe $filename}
			if {$mode==2} {return Wrench}
		}

		if {[file extension $filename] == ""} {
			if {$mode ==2} {return File}
			if {[file executable $filename] == 0} {
				if {$mode==0} {
					exec $ttbTerm -e less $filename &
				} else {
					exec $ttbTerm -e joe $filename &
				}
			} else {
				exec $filename &
			}

			return err_NOERR
		}

		if {[file extension $filename] == ".app"} {
			if {$mode ==2} {return CPUChip}
			if {[file executable $filename] == 0} {
				if {$mode==0} {
					exec $ttbTerm -e less $filename &
				} else {
					exec $ttbTerm -e joe $filename &
				}
			} else {
				exec $filename &
			}

			return err_NOERR
		}

		set if2fs [open $ttblibPath/ttb.if2 r]
		set line [split [gets $if2fs] ,]

		while {![eof $if2fs]} {
			set extlist [split [lindex $line 0] :]
			set icn [lindex $line 2]
			set com [split [lindex $line 3] :]

#			if {[llength $com]==1 && $mode == 1} { puts [llength $com];return err_VIEWONLY }
			set opt [split [lindex $line 4] :]

			for {set i 0} {$i<[llength $extlist]} {incr i} {
				if {[eval string compare .[lindex $extlist $i] [file extension $filename]]==0} {
					if {$mode == 2} {
						close $if2fs
						return $icn
					}

					switch [lindex $line 1] {
						00 {
							exec [lindex $com $mode] $filename [lindex $opt $mode] &
						}
						01 {
							exec $ttbTerm -e [lindex $com $mode] $filename [lindex $opt $mode] &
						}
					}
				}
			}
			set line [split [gets $if2fs] ,]
		}
		close $if2fs

		if {$mode ==2} {return FileUnknown}
	}
}

