#######################################################
# make and show Items
#
#				 1/19.1998

proc ttb_showItems {} {
	global ttblibPath itemWidth itemHeight stageWidth stageHeight panelColor stageColor

	if [winfo exists .itemLaunch] {
		raise .itemLaunch
		return
	}

	set files {}

	toplevel .itemLaunch -bd 10 -relief flat -bg $panelColor

	wm title .itemLaunch "T.T.B. Item launcher"


	image create photo itemImage -file "$ttblibPath/icons/system/FilecabinetOpen.gif"

	set files [glob $ttblibPath/itm/*.itm]

	for {set i 0} {$i<[llength $files]} {incr i} {

		set tempName [file rootname [lindex [split [lindex $files $i] /] end]]

		frame .itemLaunch.itm$i -width 96 -height 72 -bd 2 -relief groove -bg $stageColor
		pack .itemLaunch.itm$i -in .itemLaunch -side left -fill both
		pack propagate .itemLaunch.itm$i false

		label .itemLaunch.itm$i.icn -image itemImage -bg $stageColor
		pack .itemLaunch.itm$i.icn -in .itemLaunch.itm$i

		label .itemLaunch.itm$i.txt -text $tempName -bg $stageColor
		pack .itemLaunch.itm$i.txt -in .itemLaunch.itm$i

		bind .itemLaunch.itm$i.icn <Double-ButtonPress-1> "ttb_readItems $tempName slave"
		bind .itemLaunch.itm$i.txt <Double-ButtonPress-1> "ttb_readItems $tempName slave"
	}
}

proc ttb_readItems {itmFile mode} {
	global ttblibPath itemWidth itemHeight stageWidth stageHeight panelColor stageColor

	if {[winfo exists .$itmFile]} {
		destroy .$itmFile
		return
	}

	if [file exists $ttblibPath/itm/$itmFile.itm] {

		if {$mode!="master"} {
			set tl .$itmFile
			toplevel $tl -bd 10 -bg $panelColor

			set width 96
			set height 72
		} else {
			set tl .container.shortcuts

			set width $itemWidth
			set height $itemHeight
		}

		set ttbitm [open $ttblibPath/itm/$itmFile.itm r]
		set line [split [gets $ttbitm] \;]

		set i 0

		while {![eof $ttbitm]} {
			set itemMode  [lindex $line 0]
			set itemTitle [lindex $line 1]
			set itemFile  [lindex $line 2]
			set itemIcon  [lindex $line 3]

			frame $tl.$i -width $width -height $height -bg $panelColor
			pack $tl.$i -in $tl -side left
			pack propagate $tl.$i false

			image create photo shortcut$i$tl -file "$ttblibPath/icons/shortCuts/$itemIcon.gif"

			label $tl.$i.icon -image shortcut$i$tl -bd 0 -bg $panelColor
			label $tl.$i.fname -text $itemTitle -bg $panelColor \
				-width 16 -height 2 -anchor n -wraplength 120

			if {$mode!="master"} {
				$tl.$i configure -bd 2 -relief groove -bg $stageColor
				$tl.$i.icon configure -bg $stageColor
				$tl.$i.fname configure -bg $stageColor
			}

			pack $tl.$i.icon $tl.$i.fname -in $tl.$i

			if {$itemMode == "func"} {
				bind $tl.$i.icon <Double-ButtonPress-1> "
					$itemFile"
				bind $tl.$i.fname <Double-ButtonPress-1> "
					$itemFile"
				set line [split [gets $ttbitm] \;]
				incr i
				continue
			}


			if {[file isdirectory $itemFile]} {
				bind $tl.$i.icon <Double-ButtonPress-1> "
					ttb_showFiles 1 $itemFile"
				bind $tl.$i.fname <Double-ButtonPress-1> "
					ttb_showFiles 1 $itemFile"
			} else {
				bind $tl.$i.icon <Double-ButtonPress-1> "\
					ttb_execIF2 $itemFile 0"

				bind $tl.$i.fname <Double-ButtonPress-1> "\
					ttb_execIF2 $itemFile 0"

				bind $tl.$i.icon <Drop> "exec $itemFile %D &"

				bind $tl.$i.fname <Drop> "exec $itemFile %D &"
			}
			set line [split [gets $ttbitm] \;]
			incr i
		}
		close $ttbitm
	}
}
