######################################
# process manipuration
#

proc ttb_proclist_truncateList {pList} {

	set retList {}

	foreach i $pList {
		if {$i == {}} {
			continue
		}

		catch [set retList [concat $retList $i]]
	}

	return $retList
}

proc ttb_proclist_sendfilename {} {

	global ttblibPath

	set cursolPoint [.plisttop.plist curselection]
	if {$cursolPoint==""} return

	set procname [string trim [lindex [.plisttop.plist get $cursolPoint] 0]]

	image delete procIcon

	if {[string last / $procname]!=-1} {
		.plisttop.processName configure -text \
			[string range $procname \
			[expr [string last / $procname]+1] \
			end]
		.plisttop.plistbody3.pathStr configure -text \
			$procname
		image create photo procIcon -file \
			$ttblibPath/icons/app/[ttb_appIconInfo [string range \
			$procname [expr [string last / $procname]+1] end]].gif

	} elseif {[string first - $procname]==0} {
		image create photo procIcon -file \
			$ttblibPath/icons/app/[ttb_appIconInfo [string \
			range $procname 1 end]].gif

		.plisttop.processName configure -text [string range $procname 1 end]
		.plisttop.plistbody3.pathStr configure -text [exec which [string range $procname 1 end]]
	} else {
		image create photo procIcon -file \
			$ttblibPath/icons/app/[ttb_appIconInfo $procname].gif

		.plisttop.processName configure -text $procname
		.plisttop.plistbody3.pathStr configure -text [exec which $procname]
	}

	switch [.plisttop.plistHide2 get $cursolPoint] {
		T {
			.plisttop.plistbody3.statStr configure -text "Stopped"
		}
		R {
			.plisttop.plistbody3.statStr configure -text "Running"
		}
		S {
			.plisttop.plistbody3.statStr configure -text "Running"
		}
		Z {
			.plisttop.plistbody3.statStr configure -text "Zonbie"
		}
	}



}

proc ttb_killproc {} {
        set cursolPoint [.plisttop.plist curselection]
        if {$cursolPoint==""} return

	set procname [.plisttop.plist get $cursolPoint]
	set procID [.plisttop.plistHide get $cursolPoint]

	set ret [tk_dialog .killok "Kill process" \
		"Process $procname terminate?" {} 1 {OK} {Cancel}] 

	if {$ret == 0} {
		exec kill [expr $procID-1+1]
		ttb_showproclist
		.plisttop.processName configure -text {}
	}
}

proc ttb_showproclist {} {

	global ttblibPath

#	set scrollPoint [lindex [.plisttop.plist yview] 1]

	image delete procIcon
	image create photo procIcon -file "$ttblibPath/icons/app/Execute.gif"

	.plisttop.processName        configure -text {}
	.plisttop.plistbody3.pathStr configure -text {}
	.plisttop.plistbody3.statStr configure -text {}

	.plisttop.plist delete 0 end
	.plisttop.plistHide delete 0 end
	.plisttop.plistHide2 delete 0 end

	set templist [split [exec ps x] \n]

	for {set i 1} {$i<[llength $templist]} {incr i} {
		set templist2 [ttb_proclist_truncateList [lindex $templist $i]]

		if {[string first ( [lindex $templist2 4]]} {
			.plisttop.plist insert end "   [lindex $templist2 4] [lindex $templist2 5]"
			.plisttop.plistHide insert end [lindex $templist2 0]
			.plisttop.plistHide2 insert end [lindex $templist2 2]
		}
	}

#	.plisttop.plist yview @0,$scrollPoint

#	after 1000 ttb_showproclist
}

proc ttb_proclist {} {

	global ttblibPath panelColor stageColor

	toplevel .plisttop -bg $panelColor
	wm title .plisttop "Processes"

	frame .plisttop.toolbar -bg $panelColor
	frame .plisttop.separator -bd 1 -relief sunken -height 2 -width 300 -bg $panelColor
	frame .plisttop.plistbody -bd 10 -bg $panelColor
	frame .plisttop.plistbody1 -bg $panelColor
	frame .plisttop.spacer -height 10 -bg $panelColor
	frame .plisttop.plistbody2 -bg $panelColor
	frame .plisttop.plistbody3 -bd 10 -bg $panelColor

	tk_optionMenu .plisttop.toolbar.menu menubuttonoptions Applications -bg $panelColor

	scrollbar .plisttop.plistscroll -command ".plisttop.plist yview"
	listbox .plisttop.plist -width 50 -height 4 -yscrollcommand ".plisttop.plistscroll set" \
		-selectborderwidth 0 -bg $stageColor
	listbox .plisttop.plistHide -selectborderwidth 0
	listbox .plisttop.plistHide2 -selectborderwidth 0

	bind .plisttop.plist <ButtonRelease-1> "ttb_proclist_sendfilename"
	bind .plisttop.plist <Double-ButtonRelease-1> "ttb_killproc"

	image create photo procIcon -file {}

	label .plisttop.processIcon -image procIcon -bg $panelColor
	label .plisttop.processName -font "-adobe-helvetica-bold-r-*--18-*" -text {} -bg $panelColor

	button .plisttop.plistrefresh -text refresh -image {} -command ttb_showproclist -bg $panelColor
	button .plisttop.plistkill -image NeXTkill -command ttb_killproc -bg $panelColor

	label .plisttop.plistbody3.baseL -width 100 -bg $panelColor
	label .plisttop.plistbody3.baseR -bg $panelColor

	label .plisttop.plistbody3.path -font "-adobe-helvetica-bold-r-*--14-*" \
		-text  "path:" -bg $panelColor
	label .plisttop.plistbody3.pathStr -text {} -font "-adobe-helvetica-*-r-*--14-*" \
		-bg $panelColor

	label .plisttop.plistbody3.stat -font "-adobe-helvetica-bold-r-*--14-*" \
		-text  "status:" -bg $panelColor

	label .plisttop.plistbody3.statStr -text {} -font "-adobe-helvetica-*-r-*--14-*" \
		-bg $panelColor

	pack .plisttop.toolbar
	pack .plisttop.separator -fill both
	pack .plisttop.plistbody
	pack .plisttop.plistbody1 .plisttop.spacer .plisttop.plistbody2 \
		-in .plisttop.plistbody -side top -fill both
	pack .plisttop.plistbody3 -fill both
	pack .plisttop.toolbar.menu -in .plisttop.toolbar
	pack .plisttop.plistscroll .plisttop.plist -in .plisttop.plistbody1 -side left -fill both
	pack .plisttop.processIcon .plisttop.processName -side left -in .plisttop.plistbody2 -anchor e
	pack .plisttop.plistkill .plisttop.plistrefresh -fill y -side right -in .plisttop.plistbody2 -anchor ne
	pack .plisttop.plistbody3.baseL .plisttop.plistbody3.baseR \
		 -side left -fill both -in .plisttop.plistbody3 -anchor nw
	pack .plisttop.plistbody3.path -side top -in .plisttop.plistbody3.baseL
	pack .plisttop.plistbody3.stat -side top -in .plisttop.plistbody3.baseL

	pack .plisttop.plistbody3.pathStr -side top -in .plisttop.plistbody3.baseR
	pack .plisttop.plistbody3.statStr -side top -in .plisttop.plistbody3.baseR

	ttb_showproclist
}
