#!/bin/sh
# the next line restarts using wish \
exec wishstep8.0 "$0" "$@"

proc ttb_about {} {

	ttb_dialog .about "about Muggy" \
		"Jun's STEP Text editor\nA tribute to Nakai Margalett Maki\nver 1.2\n\nJun Wakaya 1998."\
		jfLogo -32768 0 0 Ok

}

proc ttbMan_rootCreate {ttblibPath} {
	image create photo ttbManImage -file $ttblibPath/icons/app/ttbLogo.gif
	image create photo jfLogo -file "$ttblibPath/icons/system/JFLOGO.gif"

	label .base -image ttbManImage -bd 0 

	pack .base -fill both
	pack propagate .base false
}

proc ttbMan_bind {} {
	ttb_bind

	bind . <Double-ButtonPress-1> "exec FileViewer.app &"
}

proc ttb_showPopup {mode x y fname} {
	global ttbsendList ttbbookmarkList filt

	global muggyID junsForestID jackSpaceID clipBoardID

	if {[winfo exists .ttb_popup]} {
		destroy .ttb_popup
	}

	menu .ttb_popup -tearoff 0

	switch $mode {
		"top" {
#			.ttb_popup add command -label "about Muggy" -command ttb_about
if {$muggyID!=0} {
.ttb_popup add command -label "Unlaunch Muggy" -command "exec kill $muggyID"
set muggyID 0
} else {
.ttb_popup add command -label "Launch Muggy" -command "ttb_exec Muggy"
}

			.ttb_popup add command -label "exit" -command ttb_exit
		}

	}
	tk_popup .ttb_popup $x $y
}

proc ttb_exec appName {

	global muggyID junsForestID jackSpaceID clipBoardID

set line {}

	switch $appName {

		Muggy {
			set muggyID [exec Muggy.app 10 &]
		}

		JunsForest {
			set junsForestID [exec JunsForest.app [lindex $line 1] &]
		}

		JackSpace {
			set jackSpaceID [exec JackSpace.app [lindex $line 1] &]
		}

		ClipBoard {
			set clipBoardID [exec ClipBoard.app [lindex $line 1] &]
		}

	}
}

proc ttb_readPlace {} {
	global placeNo placeList place_found
	global muggyID junsForestID jackSpaceID clipBoardID

	if [file exists ~/GNUstep/Library/JunsSTEP/ttbplace] {
		set ttbplace [open ~/GNUstep/Library/JunsSTEP/ttbplace r]
		set line [split [gets $ttbplace]]

		while {![eof $ttbplace]} {
			switch [lindex $line 0] {

				Muggy {
					set muggyID [exec Muggy.app [lindex $line 1] &]
				}

				JunsForest {
					set junsForestID [exec JunsForest.app [lindex $line 1] &]
				}

				JackSpace {
					set jackSpaceID [exec JackSpace.app [lindex $line 1] &]
				}

				ClipBoard {
					set clipBoardID [exec ClipBoard.app [lindex $line 1] &]
				}

			}

		        set line [split [gets $ttbplace]]
		}
		close $ttbplace

		set placeList [lsort $placeList]
	} else {
		puts "JunsSTEP isn't installed."
		exit
	}

	set coun [llength $placeList]

	for {set i 0} {$i>$coun} {incr i 2} {
		puts [lindex $placeList $i]
	}
}


set placeNo 0
set appName TTB

set muggyID 0
set junsForestID 0
set jackSpaceID 0
set clipBoardID 0

array name placeArray

set ttblibPath $env(HOME)/GNUstep/Library/JunsSTEP
set ttblogo $ttblibPath/icons/system/JFLOGO.gif
set stageColor {}
set panelColor {}

source $ttblibPath/functions/ttb_dialog.tcl
source $ttblibPath/functions/ttbinit.tcl

ttbMan_rootCreate $ttblibPath
ttb_resize
ttbMan_bind

ttb_readPlace
